Module | Erubis::RubyEvaluator
In: | erubis/evaluator.rb

evaluator for Ruby

### Methods

def_method evaluate result

### Included Modules

Evaluator

### Public Instance methods

def_method(object, method_name, filename=nil)

if object is an Class or Module then define instance method to it, else define singleton method to it.

[Source]

    # File erubis/evaluator.rb, line 79
        def def_method(object, method_name, filename=nil)
          m = object.is_a?(Module) ? :module_eval : :instance_eval
          object.__send__(m, "def #{method_name}; #{@src}; end", filename || @filename || '(erubis)')
        end

evaluate(_context=Context.new)

invoke context.instance_eval(@src)

[Source]

    # File erubis/evaluator.rb, line 69
        def evaluate(_context=Context.new)
          _context = Context.new(_context) if _context.is_a?(Hash)
          #return _context.instance_eval(@src, @filename || '(erubis)')
          #@_proc ||= eval("proc { #{@src} }", Erubis::EMPTY_BINDING, @filename || '(erubis)')
          @_proc ||= eval("proc { #{@src} }", binding(), @filename || '(erubis)')
          return _context.instance_eval(&@_proc)
        end

result(_binding_or_hash=TOPLEVEL_BINDING)

eval(@src) with binding object

[Source]

    # File erubis/evaluator.rb, line 53
        def result(_binding_or_hash=TOPLEVEL_BINDING)
          _arg = _binding_or_hash
          if _arg.is_a?(Hash)
            _b = binding()
            eval _arg.collect{|k,v| "#{k} = _arg[#{k.inspect}]; "}.join, _b
          elsif _arg.is_a?(Binding)
            _b = _arg
          elsif _arg.nil?
            _b = binding()
          else
            raise ArgumentError.new("#{self.class.name}#result(): argument should be Binding or Hash but passed #{_arg.class.name} object.")
          end
          return eval(@src, _b, (@filename || '(erubis'))
        end

[Validate]